<?php

namespace Teknisa\MAN\Services;

use Doctrine\ORM\EntityManager;
use Teknisa\MAN\Utilities;

class RelProdutosVendidoNormalPromoService {

	public function __construct(EntityManager $entityManager) {
        $this->entityManager = $entityManager;
    }
    
    public function find ($CDFILIAL, $NRORG, $CDLOJA, $TCDLOJA, $DTVENDAINI, $DTVENDAFIN, $CDPRODLIST, $CDPRODINI, $CDPRODFIN ,$PRODNIV, $TCDPRODUTO) {
        
        $params = array(
         	':CDFILIAL' => $CDFILIAL,
         	':NRORG' => $NRORG,
         	':CDLOJA' => $CDLOJA,
         	':TCDLOJA' => $TCDLOJA,
         	':DTVENDAINI' => $DTVENDAINI,
         	':DTVENDAFIN' => $DTVENDAFIN,
         	':CDPRODLIST' => $CDPRODLIST,
         	':CDPRODINI'  => $CDPRODINI,
         	':CDPRODFIN'  => $CDPRODFIN,
         	':PRODNIV'  =>  $PRODNIV,
         	':TCDPRODUTO' => $TCDPRODUTO
 		);
 		return $this->entityManager->getConnection()->fetchAll(self::GET_PRODUTOS_VENDIDOS_NORMAL_PROMO, $params);
    }

    const GET_PRODUTOS_VENDIDOS_NORMAL_PROMO = "
         SELECT A.CDFILIAL||' - '||A.NMFILIAL AS LABELFILIAL, A.CDLOJA||' - '||A.NMLOJA AS LABELLOJA, SUM(QTDE) AS QTDENORMAL, SUM(QTDEPRO) AS QTDEPROM, SUM(QTDE + QTDEPRO) AS TOTAL ,  
               SUM(CONTADOR) AS NRPRODUTO , A.SGUNIDADE, A.CDARVPROD, A.NMPRODUTO, A.CDFILIAL, A.CDLOJA, A.NMFILIAL, A.NMLOJA, SUM(VRTOTAL) AS VRTOTAL,
               SUM(VRTOTALPRO) AS VRTOTALPRO, ROUND((SUM(VRTOTAL + VRTOTALPRO)/SUM(CONTADOR)),2) AS PRECMEDIO
          FROM ( SELECT COUNT(*) AS CONTADOR, SUM(IT.QTPRODVEND) AS QTDE, 0 AS QTDEPRO, 0 AS VRTOTALPRO, 
                   SUM(TRUNC(IT.QTPRODVEND * (NVL(IT.VRUNITVEND,0) + NVL(IT.VRUNITVENDCL,0)),2) - NVL(IT.VRDESITVEND,0) + NVL(IT.VRACRITVEND,0)) AS VRTOTAL,
                   P.SGUNIDADE, P.CDARVPROD, P.NMPRODUTO, FILOCAVE.CDFILIAL, FILOCAVE.CDLOJA, FILOCAVE.NMFILIAL, FILOCAVE.NMLOJA
              FROM ITEMVENDA IT
              JOIN PRODUTO P
                ON IT.CDPRODUTO = P.CDPRODUTO                                
               AND IT.NRORG = P.NRORG
              JOIN (SELECT V.IDSITUVENDA, V.NRSEQVENDA, FILOCA.CDCAIXA, FILOCA.CDLOJA, FILOCA.CDFILIAL, FILOCA.NRORG, FILOCA.NMFILIAL, FILOCA.NMLOJA
                      FROM VENDA V
                      JOIN ( SELECT C.CDCAIXA, FILO.CDLOJA, FILO.CDFILIAL, FILO.NRORG, FILO.NMFILIAL, FILO.NMLOJA
                               FROM CAIXA C
                               JOIN ( SELECT L.CDLOJA, FI.CDFILIAL, FI.NRORG, FI.NMFILIAL, L.NMLOJA
                                        FROM LOJA L
                                        JOIN ( SELECT F.CDFILIAL, F.NRORG, F.NMFILIAL
                                                 FROM FILIAL F
                                                WHERE ((INSTR(:CDFILIAL , F.CDFILIAL ) <> 0))
                                                  AND F.NRORG = :NRORG 
                                             ) FI
                                          ON L.CDFILIAL = FI.CDFILIAL
                                         AND L.NRORG = FI.NRORG 
                                       WHERE ((INSTR(:CDLOJA, FI.CDFILIAL||L.CDLOJA) <> 0) OR (:TCDLOJA   = 'T'))
                                    ) FILO
                                 ON C.CDFILIAL = FILO.CDFILIAL
                                AND C.CDLOJA = FILO.CDLOJA
                                AND C.NRORG = FILO.NRORG
                           ) FILOCA
                        ON V.CDCAIXA = FILOCA.CDCAIXA
                       AND V.CDLOJA = FILOCA.CDLOJA
                       AND V.CDFILIAL = FILOCA.CDFILIAL
                       AND V.NRORG = FILOCA.NRORG
                     WHERE V.IDSITUVENDA = 'O'
                       AND V.DTENTRVENDA BETWEEN :DTVENDAINI AND :DTVENDAFIN
                   ) FILOCAVE
                ON IT.NRSEQVENDA = FILOCAVE.NRSEQVENDA
               AND IT.CDCAIXA = FILOCAVE.CDCAIXA
               AND IT.CDFILIAL = FILOCAVE.CDFILIAL
               AND IT.NRORG = FILOCAVE.NRORG
            WHERE
          ( ( ( ( INSTR(:CDPRODLIST, IT.CDPRODUTO) > 0 )
                OR ( P.CDPRODUTO BETWEEN :CDPRODINI AND :CDPRODFIN ) ) 
            OR ( P.CDARVPROD LIKE :PRODNIV ) )
          OR ( :TCDPRODUTO = 'T' ) )          
             GROUP BY P.CDARVPROD,P.SGUNIDADE,P.NMPRODUTO,FILOCAVE.CDFILIAL,FILOCAVE.CDLOJA,FILOCAVE.NMFILIAL,FILOCAVE.NMLOJA            
             
             

            UNION
            
            SELECT COUNT(*) AS CONTADOR, 0 AS QTDE,  SUM(QTITVENDAEST) AS QTDEPRO,
                   SUM(TRUNC(IV.QTITVENDAEST * (NVL(IV.VRUNVENDAEST,0) - NVL(IV.VRDESITVENDAEST,0)),2)) AS VRTOTALPRO, 
                   0 AS VRTOTAL, P.SGUNIDADE, P.CDARVPROD, P.NMPRODUTO, FILOCAVE.CDFILIAL, FILOCAVE.CDLOJA, FILOCAVE.NMFILIAL, FILOCAVE.NMLOJA
              FROM ITEMVENDAEST IV
              JOIN PRODUTO P
                ON IV.CDPRODUTO = P.CDPRODUTO
               AND IV.NRORG = P.NRORG
              JOIN (SELECT V.IDSITUVENDA, V.NRSEQVENDA, FILOCA.CDCAIXA, FILOCA.CDLOJA, FILOCA.CDFILIAL, FILOCA.NRORG, FILOCA.NMFILIAL, FILOCA.NMLOJA
                      FROM VENDA V
                      JOIN ( SELECT C.CDCAIXA, FILO.CDLOJA, FILO.CDFILIAL, FILO.NRORG, FILO.NMFILIAL, FILO.NMLOJA
                               FROM CAIXA C
                               JOIN ( SELECT L.CDLOJA, FI.CDFILIAL, FI.NRORG, FI.NMFILIAL, L.NMLOJA
                                        FROM LOJA L
                                        JOIN ( SELECT F.CDFILIAL, F.NRORG, F.NMFILIAL
                                                 FROM FILIAL F
                                                WHERE ((INSTR(:CDFILIAL , F.CDFILIAL ) <> 0))
                                                  AND F.NRORG = :NRORG 
                                             ) FI
                                          ON L.CDFILIAL = FI.CDFILIAL
                                         AND L.NRORG = FI.NRORG 
                                       WHERE ((INSTR(:CDLOJA, FI.CDFILIAL||L.CDLOJA) <> 0) OR (:TCDLOJA   = 'T'))
                                    ) FILO
                                 ON C.CDFILIAL = FILO.CDFILIAL
                                AND C.CDLOJA = FILO.CDLOJA
                                AND C.NRORG = FILO.NRORG
                           ) FILOCA
                        ON V.CDCAIXA = FILOCA.CDCAIXA
                       AND V.CDLOJA = FILOCA.CDLOJA
                       AND V.CDFILIAL = FILOCA.CDFILIAL
                       AND V.NRORG = FILOCA.NRORG
                     WHERE V.IDSITUVENDA = 'O'
                       AND V.DTENTRVENDA BETWEEN :DTVENDAINI AND :DTVENDAFIN
                   ) FILOCAVE
                ON IV.NRSEQVENDA = FILOCAVE.NRSEQVENDA
               AND IV.CDCAIXA = FILOCAVE.CDCAIXA
               AND IV.CDFILIAL = FILOCAVE.CDFILIAL
               AND IV.NRORG = FILOCAVE.NRORG
                WHERE
           ( ( ( ( ( INSTR(:CDPRODLIST, IV.CDPRODUTO) > 0 )
                OR ( P.CDPRODUTO BETWEEN :CDPRODINI AND :CDPRODFIN ) ) )
            OR ( P.CDARVPROD LIKE :PRODNIV ) )
          OR ( :TCDPRODUTO = 'T' ) )
             GROUP BY P.CDARVPROD,P.SGUNIDADE,P.NMPRODUTO,FILOCAVE.CDFILIAL,FILOCAVE.CDLOJA,FILOCAVE.NMFILIAL,FILOCAVE.NMLOJA             
            )A           
          GROUP BY A.SGUNIDADE, A.CDARVPROD,A.NMPRODUTO,A.CDFILIAL,A.CDLOJA,A.NMFILIAL,A.NMLOJA
          ORDER BY A.CDFILIAL, A.CDLOJA , A.CDARVPROD 
    ";
    
    
}